/**
 * 
 */
package RunCases;

import java.sql.ResultSet;

import tools.MyDatabaseTools;

/**
 * @author Bastian Christoph
 *
 */
public class RunDropAllCreateAgainPostgres {

	static MyDatabaseTools dbTools = new MyDatabaseTools();
	static String sql;
	static ResultSet rsSelect;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		dbTools.createDBConnection();
		
		dropTables();
		createTables();
		addForeignKeys();
		
		insertHersteller();	
		insertProdukt();
		insertLager();	
		insertBestellposten();
		
	}

	/**
	 * 
	 */
	private static void dropTables() {
		sql = "DROP TABLE Bestellposten";
		dbTools.executeDBUpdate(sql);
		sql = "DROP TABLE Lager";
		dbTools.executeDBUpdate(sql);
		sql = "DROP TABLE Produkt";
		dbTools.executeDBUpdate(sql);
		sql = "DROP TABLE Hersteller";
		dbTools.executeDBUpdate(sql);
	}

	/**
	 * 
	 */
	private static void createTables() {
		sql = "CREATE TABLE Hersteller ("
				+ "Name VARCHAR( 20 ) NOT NULL ,"
				+ "Land VARCHAR( 20 ) NOT NULL ,"
				+ "Stadt VARCHAR( 20 ) NOT NULL ,"
				+ "PRIMARY KEY ( Name )"
				+ ")";
		dbTools.executeDBUpdate(sql);
		sql = "CREATE TABLE Produkt ("
				+ "Name VARCHAR( 20 ) NOT NULL ,"
				+ "Hersteller VARCHAR( 20 ) NOT NULL ,"
				+ "Preis DECIMAL( 6, 2 ) NOT NULL ,"
				+ "PRIMARY KEY ( Name ) ,"
				+ "FOREIGN KEY ( Hersteller ) REFERENCES Hersteller( Name )"
				+ ")";
		dbTools.executeDBUpdate(sql);
		sql = "CREATE TABLE Lager ("
				+ "ProduktName VARCHAR( 20 ) NOT NULL ,"
				+ "Groesse INT NOT NULL ,"
				+ "Anzahl INT NOT NULL ,"
				+ "PRIMARY KEY ( ProduktName, Groesse ), "
				+ "FOREIGN KEY ( ProduktName ) REFERENCES Produkt( Name )"
				+ ")";
		dbTools.executeDBUpdate(sql);
		sql = "CREATE TABLE Bestellposten ("
				+ "Bestellung INT NOT NULL ,"
				+ "Name VARCHAR( 20 ) NOT NULL ,"
				+ "Groesse INT NOT NULL ,"
				+ "Anzahl INT NOT NULL ,"
				+ "PRIMARY KEY ( Bestellung , Name , Groesse ), "
				+ "CONSTRAINT fk_ProduktName FOREIGN KEY ( Name ) REFERENCES Produkt( Name )"
				+ ")";
		dbTools.executeDBUpdate(sql);
	}

	/**
	 * 
	 */
	private static void addForeignKeys() {
		sql = "ALTER TABLE Produkt ADD FOREIGN KEY ( Hersteller ) REFERENCES Hersteller( Name )";
		dbTools.executeDBUpdate(sql);
		sql = "ALTER TABLE Lager ADD FOREIGN KEY ( ProduktName ) REFERENCES Produkt( Name )";
		dbTools.executeDBUpdate(sql);
		sql = "ALTER TABLE Bestellposten ADD FOREIGN KEY ( Name ) REFERENCES Produkt( Name )";
		dbTools.executeDBUpdate(sql);
	}

	/**
	 * 
	 */
	private static void insertHersteller() {
		dbTools.doInsert("Hersteller", new String[]{"Bally", "Schweiz", "Caslano"} );
		dbTools.doInsert("Hersteller", new String[]{"Camper", "Spanien", "Inca"} );
		dbTools.doInsert("Hersteller", new String[]{"Reebok", "USA", "Canton MA"} );
		dbTools.doInsert("Hersteller", new String[]{"Mephisto", "Frankreich", "Sarrebourg"} );
	}

	/**
	 * 
	 */
	private static void insertProdukt() {
		dbTools.doInsert("Produkt", new String[]{"Kaisy 8200", "Mephisto", "99.90"} );
		dbTools.doInsert("Produkt", new String[]{"Evaluate Trainer", "Reebok", "49.95"} );
		dbTools.doInsert("Produkt", new String[]{"CA 226130990", "Camper", "135.00"} );	
		dbTools.doInsert("Produkt", new String[]{"Dianetten", "Bally", "220.00"} );
		dbTools.doInsert("Produkt", new String[]{"Edesio 1965", "Mephisto", "135.00"} );
		dbTools.doInsert("Produkt", new String[]{"Paris Runner", "Reebok", "74.95"} );	
		dbTools.doInsert("Produkt", new String[]{"CA 22225090", "Camper", "139.90"} );	
		dbTools.doInsert("Produkt", new String[]{"Delarosa", "Bally", "350.00"} );
	}

	/**
	 * 
	 */
	private static void insertLager() {
		dbTools.doInsert("Lager", new String[]{"Kaisy 8200", "37", "9"} );
		dbTools.doInsert("Lager", new String[]{"Kaisy 8200", "38", "16"} );
		dbTools.doInsert("Lager", new String[]{"Evaluate Trainer", "41", "47"} );
		dbTools.doInsert("Lager", new String[]{"Evaluate Trainer", "43", "11"} );
		dbTools.doInsert("Lager", new String[]{"CA 226130990", "39", "28"} );
		dbTools.doInsert("Lager", new String[]{"Dianetten", "45", "22"} );
		dbTools.doInsert("Lager", new String[]{"Dianetten", "44", "42"} );
		dbTools.doInsert("Lager", new String[]{"Edesio 1965", "41", "57"} );
		dbTools.doInsert("Lager", new String[]{"Edesio 1965", "42", "63"} );
		dbTools.doInsert("Lager", new String[]{"Edesio 1965", "43", "74"} );
		dbTools.doInsert("Lager", new String[]{"Paris Runner", "42", "7"} );
		dbTools.doInsert("Lager", new String[]{"Delarosa", "36", "66"} );
		dbTools.doInsert("Lager", new String[]{"Delarosa", "37", "87"} );
		dbTools.doInsert("Lager", new String[]{"Delarosa", "38", "85"} );
	}
	
	/**
	 * 
	 */
	private static void insertBestellposten() {
		dbTools.doInsert("Bestellposten", new String[]{"3297", "Evaluate Trainer", "43", "1"} );
		dbTools.doInsert("Bestellposten", new String[]{"3297", "Dianetten", "44", "1"} );
		dbTools.doInsert("Bestellposten", new String[]{"7982", "Kaisy 8200", "37", "1"} );
		dbTools.doInsert("Bestellposten", new String[]{"7982", "Delarosa", "37", "1"} );
	}

}
