package structures;

/**
 * 
 */

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

/**
 * @author Bastian Christoph
 *
 */
public class ArrayListOfString extends ArrayList<String> {

	/**
	 * 
	 */
	private static final long serialVersionUID = -933832669046364790L;

	public String quoteChars(String param) {
		String toQuote = "";
		String quoted = "";
		
		try {
			toQuote = new String(param.getBytes(), "UTF-8");
			
			quoted = toQuote.replaceAll("'", "\\\\'");
			quoted = quoted.replaceAll("\\(", "\\\\(");
			quoted = quoted.replaceAll("\\)", "\\\\)");
			
			quoted = quoted.replaceAll(":", "\\\\:");
			
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
		return quoted;
	}
	
	public ArrayListOfString quoteStrings() {
		ArrayListOfString quotedList = new ArrayListOfString();
		
		for(String element: this) {
			quotedList.add(quoteChars(element));
		}
		
		return quotedList;
	}
	
	public void printList() {
		for(String element: this) {
			System.out.println(element);
		}
	}

	public void printSize() {
		System.out.println("Count: " + this.size());
	}
}
