package tools;
/**
 * 
 */

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

/**
 * @author Bastian Christoph
 *
 */
public class DBResultPrinter {
	
	public static void printResult(ResultSet rs) {
		
		try {
			int i, n;
			
		    ResultSetMetaData rsmd = rs.getMetaData();
			n = rsmd.getColumnCount();
			
		    // Print table content:
		    for( i=0; i<n; i++ )
		    	System.out.print( "+-------------------" );
		    
		    System.out.println( "+" );
		    for( i=1; i<=n; i++ )    // Attention: first column with 1 instead of 0
		    	System.out.print( "| " + extendStringTo14( rsmd.getColumnName( i ) ) );
		    
		    System.out.println( "|" );
		    for( i=0; i<n; i++ )
		    	System.out.print( "+-------------------" );
		    
		    System.out.println( "+" );
		    
		    int actual = 0;
		    
		    while( rs.next() ) {
		    	for( i=1; i<=n; i++ ) {  // Attention: first column with 1 instead of 0
		    		System.out.print( "| " + extendStringTo14( rs.getString( i ) ) );
		    		actual += 1;
		    	}
		    	
		    	System.out.println( "|" );
		    }
		    
		    for( i=0; i<n; i++ )
		    	System.out.print( "+-------------------" );
		    
		    System.out.println( "+" );
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	// Extend String to length of 14 characters
	private static final String extendStringTo14( String s ) {
		if( null == s ) s = "";
	    final String sFillStrWithWantLen = "                  ";
	    final int iWantLen = sFillStrWithWantLen.length();
	    final int iActLen  = s.length();
	    
	    if( iActLen < iWantLen )
	      return (s + sFillStrWithWantLen).substring( 0, iWantLen );
	    
	    if( iActLen > 2 * iWantLen )
	      return s.substring( 0, 2 * iWantLen );
	    
	    return s;
	}
}
