/**
 * 
 */
package tools;

import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import structures.ArrayListOfString;

/**
 * @author Bastian Christoph
 *
 */
public abstract class DatabaseTools implements IDatabaseTools {

	protected Statement  st = null;
	protected int rsUpdate;
	protected ResultSet rsSelect;
	
	protected Connection cn = null;
	protected String queryTableName;
	protected String queryColumnName;
	protected boolean doPrint = true;
	
	public void setQueryTable(String tableName) {
		this.queryTableName = tableName;
	}

	public void setListColumnName(String columnName) {
		this.queryColumnName = columnName;
	}

	public Connection getConnection() {
		return this.cn;
	}
	
	public void setDoPrint(boolean doPrint) {
		this.doPrint = doPrint;
	}
	
	public ArrayListOfString getArrayListByQuery() {
		ArrayListOfString stringList = new ArrayListOfString();
		
		String sql = "SELECT " + this.queryColumnName
					+ " FROM " + this.queryTableName;
		
	    try {
			st = this.cn.createStatement();
			
			System.out.println(sql);
		    rsSelect = st.executeQuery( sql );
		    
		    while( rsSelect.next() ) {
		    	String element = rsSelect.getString(1);
		    	
		    	stringList.add(element);
		    }
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return stringList;
	}

	public ArrayListOfString getArrayListByQueryLike(String columnValue) {
		ArrayListOfString stringList = new ArrayListOfString();
		
		String sql = "SELECT " + this.queryColumnName
					+ " FROM " + this.queryTableName
					+ " WHERE " + this.queryColumnName + " like '" + columnValue + "'";
		
	    try {
			st = this.cn.createStatement();
			
			System.out.println(sql);
		    rsSelect = st.executeQuery( sql );
		    
		    while( rsSelect.next() ) {
		    	String element = rsSelect.getString(1);
		    	
		    	stringList.add(element);
		    }
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return stringList;
	}

	public ArrayListOfString getArrayListByQueryEqual(String columnValue) {
		ArrayListOfString stringList = new ArrayListOfString();
		
		String sql = "SELECT " + this.queryColumnName
					+ " FROM " + this.queryTableName
					+ " WHERE " + this.queryColumnName + " = '" + columnValue + "'";
		
	    try {
			st = this.cn.createStatement();
			
			System.out.println(sql);
		    rsSelect = st.executeQuery( sql );
		    
		    while( rsSelect.next() ) {
		    	String element = rsSelect.getString(1);
		    	
		    	stringList.add(element);
		    }
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return stringList;
	}

	public ResultSet getResultSet() {
		return this.rsSelect;
	}

	public String getResultField(int fieldIndex) {
		String fieldValue = "";
			
		int count = 0;
			
		try {
			while( this.rsSelect.next() ) {
				count++;
			    	
				fieldValue = this.rsSelect.getString( fieldIndex );
			}
				
		} catch (SQLException e) {
			e.printStackTrace();
		}
			
		return fieldValue;
	}

	public void executeDBUpdate(String sql) {
	    try {
			st = this.cn.createStatement();
			
			System.out.println(sql);
		    rsUpdate = st.executeUpdate( sql );
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		System.out.println();
	}

	public void executeDBSelect(String sql) {
	    try {
			st = this.cn.createStatement();
			
			if(this.doPrint ) {
				System.out.println(sql);
			}
			
		    rsSelect = st.executeQuery( sql );
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		if(this.doPrint ) {
			System.out.println();
		}
	}

	public String quoteCharsUTF8(String param) {
		
		String toQuote = "";
		String quoted = "";
				
		try {
			toQuote = new String(param.getBytes(), "UTF-8");
				
				
			quoted = toQuote.replaceAll("'", "\\\\'");
			quoted = quoted.replaceAll("\\(", "\\\\(");
			quoted = quoted.replaceAll("\\)", "\\\\)");
			
			quoted = quoted.replaceAll(":", "\\\\:");
			
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
			
		return quoted;
	}

	public String quoteChars(String param) {
				
		String toQuote = "";
		String quoted = "";
		
		toQuote = param;
				
		quoted = toQuote.replaceAll("'", "\\\\'");
		quoted = quoted.replaceAll("\\(", "\\\\(");
		quoted = quoted.replaceAll("\\)", "\\\\)");
		
		quoted = quoted.replaceAll(":", "\\\\:");
					
		return quoted;
	}
	
}
