package tools;
/**
 * 
 */

import java.sql.DriverManager;
import java.sql.SQLException;

import structures.ArrayListOfString;

/**
 * @author Bastian Christoph
 *
 */
public class DatabaseTools_Mysql extends DatabaseTools {
	
	public void createDBConnection() {
		try {
			Class.forName( "com.mysql.jdbc.Driver" );
			
			String serverIP = "localhost";
			String dbName = "dkess10";
			String sUsr = "<dbuser>";
			String sPwd = "<dbpasswd>";
			
			this.cn = DriverManager.getConnection( "jdbc:mysql://" + serverIP + ":3306/"+dbName, sUsr, sPwd );
			
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void createTableFromTable(String newTable, String baseTable) {
		String sql = "";
		
	    try {
			st = this.cn.createStatement();
			
			// SQL: Create new table from base-table
			sql = "DROP TABLE IF EXISTS " + newTable;
			System.out.println(sql);
		    rsUpdate = st.executeUpdate( sql );
		    
			// SQL: Create new table from base-table
			sql = "CREATE TABLE IF NOT EXISTS " + newTable
				+ " SELECT * FROM " + baseTable + " LIMIT 1,1";
			System.out.println(sql);
		    rsUpdate = st.executeUpdate( sql );
		    
		    // SQL: Delete all entries from new table
			sql = "TRUNCATE TABLE " + newTable;
			System.out.println(sql);
		    rsUpdate = st.executeUpdate( sql );
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void addPrimaryKeyToTable(String newTable, String primaryKeyName) {
		String sql = "";
		
	    try {
			st = this.cn.createStatement();
			
			sql = "ALTER TABLE `" + newTable + "` " +
					"ADD PRIMARY KEY ( `" + primaryKeyName + "` )";
			System.out.println(sql);
		    rsUpdate = st.executeUpdate( sql );
		    
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void insertFromTable(String toTable, String fromTable,
			String columnName, String columnValue) {
		
		String sql = "INSERT INTO " + toTable +
					" SELECT * FROM "+fromTable+
					" WHERE " + columnName + " = '" + columnValue + "'";
			
		executeDBUpdate(sql);		
	}
	
	public void insertFromTableNoDuplicates(String toTable, String fromTable,
			String columnName, String columnValue) {
		
		this.queryTableName = toTable;
		this.queryColumnName = columnName;
		ArrayListOfString valueList = getArrayListByQueryLike(columnValue);
		
		// query result empty
		if(valueList.size() == 0) {
			System.out.println("column value not found! -> doing insert ...");
			
			String sql = "INSERT INTO " + toTable +
						" SELECT * FROM "+fromTable+
						" WHERE " + columnName + " like '" + columnValue + "'";
			
			executeDBUpdate(sql);
			
		} else {
			System.out.println("column value found: " + columnValue);
		}
		
	}

	/*
	 * Compile and invoke INSERT-Statement
	 */
	public void doInsert(String table, String[] rowTuple) {
		String sql = "";
		sql += "INSERT INTO " + table + " VALUES (";
		for(int i=0; i<rowTuple.length-1; i++) {
			sql += "'" + rowTuple[i] + "'";
			sql += ", ";
		}
		sql += "'" + rowTuple[rowTuple.length-1] + "'";
		sql += ")";
		
		this.executeDBUpdate(sql);
	}
	
}
