/**
 * 
 */
package tools;

import java.sql.Connection;
import java.sql.ResultSet;

import structures.ArrayListOfString;

/**
 * @author Bastian Christoph
 *
 */
public interface IDatabaseTools {
	public void setQueryTable(String tableName);
	public void setListColumnName(String columnName);
	
	public Connection getConnection();
	public void setDoPrint(boolean doPrint);
	
	public ArrayListOfString getArrayListByQuery();
	public ArrayListOfString getArrayListByQueryLike(String columnValue);
	public ArrayListOfString getArrayListByQueryEqual(String columnValue);
	
	public ResultSet getResultSet();
	public String getResultField(int fieldIndex);
	
	public void executeDBUpdate(String sql);
	public void executeDBSelect(String sql);
	
	public void createDBConnection();
	public void createTableFromTable(String newTable, String baseTable);
	
	public void addPrimaryKeyToTable(String newTable, String primaryKeyName);
	
	public String quoteCharsUTF8(String param);
	public String quoteChars(String param);
	
	public void insertFromTable(String toTable, String fromTable, String columnName, String columnValue);
	public void insertFromTableNoDuplicates(String toTable, String fromTable, String columnName, String columnValue);
	
	public void doInsert(String table, String[] rowTuple);
}
